package com.example.molinobd;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

public class BuscadorActivity  extends Activity {
	private static final String DEBUG_TAG="Warning";
	
	// URL desde la que descargar la lista de molinos 
    private static String url_molino = "http://www.wilmerodriguez.mobi/MCanarios/wservices/getmolinojson.php";
    
    // Contenedor de la lista de molinos
    ArrayList<HashMap<String, String>> molinosList; 
    
    // ListView 
    ListView listView = null;
    
    // ListView
    TextView textView = null;
    Context context = null;
    
	// Progress Dialog 
    private ProgressDialog progressDialog;
  
    // Crear el JSON Parser object 
    JSONParser jParser = new JSONParser(); 
  
    // Nombre de los nodos de JSON Object 
    private static final String TAG_SUCCESS = "success"; 
    private static final String TAG_MOLINOS = "mcanarios"; 
    private static final String TAG_ID = "ID"; 
    private static final String TAG_NOMBRE = "NOMBRE";
    private static final String TAG_TIPOLOGIA = "TIPOLOGIA";
    private static final String TAG_VOTOS = "VOTOS";
    private static final String TAG_VOTACIONES = "VOTACIONES";
  
    // Molinos JSONArray 
    JSONArray molinos = null; 
	
    //  
	private TextView txtID;
	private TextView txtNOMBRE;
	private Button btnBuscar;
	
	// Indicador de resultados JSON
	int success = 0;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_buscador);
        context = this;
        
        // Ocultar el teclado virtual apenas se abre la activity 
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
        
        // Vincular a txtBuscadorMolinosInstrucciones
        // textView = (TextView) findViewById(R.id.txtBuscadorMolinosInstrucciones);
        
        // Vincular las cajas de texto y el botn
        txtID = (TextView)findViewById(R.id.txtBuscadorMolinosTxtID);
        txtNOMBRE = (TextView)findViewById(R.id.txtBuscadorMolinosTxtNombre);
        btnBuscar = (Button)findViewById(R.id.btnBuscadorMolinos);

        // Asignar un listener al botn
        btnBuscar.setOnClickListener(listener);
        
	}
	/** 
     * Lstener encargado de gestionar cada clic en el botn buscar. 
     * */
	 private OnClickListener listener = new OnClickListener() {
	    	public void onClick(View arg0) {
	    		// Volcar en LogCat el ID seleccionado
	    		Log.w(DEBUG_TAG, "En BuscadorMolino: OnClickListener"); 
	    		
	    		// Control imagen de fondo
	            ImageView imageView1=(ImageView)findViewById(R.id.fondo);
	            imageView1.setVisibility(View.VISIBLE);


	    		//Lineas para ocultar el teclado virtual (Hide keyboard) 
	            quitarTeclado(txtID);
	            quitarTeclado(txtNOMBRE);
	                       
	            // Llamar (en segundo plano) al servicio web para obtener datos: Listado completo
	            // Hashmap for ListView 
	            
	            molinosList = new ArrayList<HashMap<String, String>>(); 
	            
	          
	            // Loading products in Background Thread 
	            new LoadMolino().execute(); 

	            // Obtener listview vinculado a la Activity
	            listView = (ListView) findViewById(R.id.txtBuscadorMolinosListMolino);
	    	}
	    };

	    /** 
	     * Background Async Task que carga el listado de todos los molinos 
	     * 		Subclase privada que crea un hilo aparte para realizar      
	     * 		las acciones que deseemos. 
	     * */
		private class LoadMolino extends AsyncTask<String, Void, Object> {
			/** 
	         * Antes de iniciarse el background thread, mostrar Progress Dialog 
	         * */
	        @Override
	        protected void onPreExecute() { 
	            super.onPreExecute(); 
	            progressDialog = new ProgressDialog(BuscadorActivity.this); 
	            progressDialog.setMessage(getResources().getString(R.string.PD_buscando_datos_molino));
	            progressDialog.setIndeterminate(false); 
	            progressDialog.setCancelable(false); 
	            progressDialog.show(); 
	        } 
	        
	        /** 
	         * Obtener todos los molinos desde la URL
	         * */
	        protected String doInBackground(String... args) { 
	            // Contenedor Parametros 
	            List<NameValuePair> params = new ArrayList<NameValuePair>(); 
	            // Obtener JSON String desde la URL, mtodo GET 
	            if (  txtID.getText().toString().length() > 0  ) {
	            	params.add(new BasicNameValuePair("ID", txtID.getText().toString()));
	            }	
	            if ( txtNOMBRE.getText().toString().length() > 0 ) {
	            	params.add(new BasicNameValuePair("NOMBRE", txtNOMBRE.getText().toString()));
	            }
	            
	            // Volcar en LogCat JSON peticin 
	            Log.w(DEBUG_TAG, "En BuscadorMolino: Valor: " + params.toString()); 
	            
	            
	            JSONObject json = jParser.makeHttpRequest(url_molino, "GET", params); 
	            
	  
	            // Volcar en LogCat JSON response  
	            Log.w(DEBUG_TAG, "En BuscadorMolino: Datos del molino: " + json.toString()); 
	  
	            try { 
	                // Comprobando la etiqueta SUCCESS 
	                success = json.getInt(TAG_SUCCESS); 
	                
	                // Volcar en LogCat JSON response  
	                Log.w(DEBUG_TAG, "En BuscadorMolino: Error success: " + success);
	                
	                // Si se ha cargado al menos un registro
	                if (success == 1) { 
	                    // products found 
	                    // Getting Array of Products 
	                    molinos = json.getJSONArray(TAG_MOLINOS); 
	  
	                    // looping through All Products 
	                    for (int i = 0; i < molinos.length(); i++) { 
	                        JSONObject c = molinos.getJSONObject(i); 
	  
	                        // Storing each json item in variable 
	                        String id = c.getString(TAG_ID); 
	                        String nombre = c.getString(TAG_NOMBRE); 
	                        String tipologia = c.getString(TAG_TIPOLOGIA);
	                        int votos = c.getInt(TAG_VOTOS);
	  
	                        // Creando el nuevo HashMap 
	                        HashMap<String, String> map = new HashMap<String, String>(); 
	  
	                        // adding each child node to HashMap key => value 
	                        map.put(TAG_ID, id); 
	                        map.put(TAG_NOMBRE, nombre);
	                        map.put(TAG_TIPOLOGIA, "Tipologa: " + tipologia);
	                        
	                        map.put(TAG_VOTOS, "Votos: " + votos );
	 //                       map.put(TAG_VOTACIONES, String.valueOf(valoracion)); 
	  
	                        // adding HashList to ArrayList 
	                        molinosList.add(map); 
	                    } 
	                } else { 
	                    // Lista vacia. No se han encontrado molinos  
	                	// Toast.makeText(context, getResources().getString(R.string.TM_lista_molinos_vacia), Toast.LENGTH_SHORT).show();
	                	// txtID.setText("La lista de molinos est vaca.");
	                } 
	            } catch (JSONException e) { 
	                e.printStackTrace(); 
	            } 
	            return null; 
	    	}
	    	
	        /** 
	         * Antes de iniciarse el background thread, ocultar Progress Dialog 
	         * */
	    	protected void onPostExecute(Object result) {
	    		// Ocultar progressDialog despus de obtener el listado de todos los molinos 
	    		progressDialog.dismiss();

	            // Actualizar UI desde  Background hilo 
	            runOnUiThread(new Runnable() { 
	                public void run() { 
	                	if ( success == 1 ) { 
	                    /** 
	                     * Actualizar JSON data en el ListView 
	                     * */
	                    ListAdapter adapter = new SimpleAdapter( 
	                            BuscadorActivity.this, molinosList, 
	                            R.layout.list_item, new String[] { TAG_ID, 
	                            								   TAG_NOMBRE, 
	                            								   TAG_TIPOLOGIA,
	                            								   TAG_VOTOS,
//	                            								   TAG_VOTACIONES
	                            								   }, 
	                            new int[] { R.id.txtListAllID, 
	                            		    R.id.txtListAllNOMBRE, 
	                            		    R.id.txtListAllTIPOLOGIA,
	                            		    R.id.txtListAllVOTOS,
//	                            		    R.id.ratingBar1
	                            		    }); 
	                    // Actualizar listview
	                    listView.setAdapter(adapter);
	                     
	                	// txtID.setText(molinosList.toString());
	                	
	                	} else {
	                		Toast.makeText(context, getResources().getString(R.string.TM_busqueda_molinos_vacia), Toast.LENGTH_SHORT).show();
		                	// molinosList.clear;
	                	}
	                } 
	            }); 
	    		
	            
	    	}
	    }
		/** 
	     * Mtodo que se encarga de ocultar el teclado virtual, 
	     * 		cuando sea necesario
	     * */
		private void quitarTeclado(View view) {
			InputMethodManager teclado = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
			teclado.hideSoftInputFromWindow(view.getWindowToken(), 0);
		}

}