package com.example.molinobd;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class ListCercanoActivity extends Activity  implements OnClickListener {
	private static final String DEBUG_TAG = "Warning";
	
	// URL desde la que descargar la lista de molinos 
    private static String url_cercano_molinos = "http://www.wilmerodriguez.mobi/MCanarios/wservices/getcercanosjson.php";
    
    // Contenedor de la lista de molinos
    ArrayList<HashMap<String, String>> molinosList; 
    
    // ListView 
    ListView listView = null;
    
    // ListView
    TextView textView = null;
    Context context = null;
    
	// Progress Dialog 
    private ProgressDialog progressDialog;
  
    // Crear el JSON Parser object 
    JSONParser jParser = new JSONParser(); 
  
    // Nombre de los nodos de JSON Object 
    private static final String TAG_SUCCESS = "success";
    private static final String TAG_MOLINOS = "mcanarios"; 
    private static final String TAG_ID = "ID"; 
    private static final String TAG_NOMBRE = "NOMBRE";
    private static final String TAG_TIPOLOGIA = "TIPOLOGIA";
    private static final String TAG_VOTOS = "VOTOS";
    private static final String TAG_VOTACIONES = "VOTACIONES";
  
    // Molinos JSONArray 
    JSONArray molinos = null; 
    
    // URI geogrfico: 
 	public String strLatitud; 
 	public String strLongitud; 
    
    // Indicador de resultados JSON
 	int success = 0;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_list_cercano);
		context = this;
		
		// Recuperar parmetros
        strLatitud = getIntent().getStringExtra("strLatitud");
        strLongitud = getIntent().getStringExtra("strLongitud");
        
        // Se verifica que los parmetros pasados sean correctos
        Log.w(DEBUG_TAG, "Warning: Datos GPS: [[[[" + strLatitud + ":" + strLongitud + "]]]] ");

		// Control imagen de fondo
        ImageView imageView1=(ImageView)findViewById(R.id.fondo);
        imageView1.setVisibility(View.VISIBLE);
        
        // Vincular a txtListAllMolinosInstrucciones
        textView = (TextView) findViewById(R.id.txtListCercanoInstrucciones);
       
        // Llamar (en segundo plano) al servicio web para obtener datos: Listado completo
        // Hashmap for ListView 
        molinosList = new ArrayList<HashMap<String, String>>(); 
      
        // Loading products in Background Thread 
       	new LoadCercanosMolinos().execute(); 
       
        	
        // Obtener listview vinculado a la Activity
        listView = (ListView) findViewById(R.id.list_cercanos_Molinos);
        
        // Al seleccionar un molino, abrir la activity individual 
        listView.setOnItemClickListener(new OnItemClickListener() { 
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) { 
                // Obtener el ID del molino seleccionado en el ListItem 
                String ID = ((TextView) view.findViewById(R.id.txtListAllID)).getText().toString(); 
  
                // Iniciar el nuevo intent 
                // Intent intent = new Intent(getApplicationContext(), MapaActivity.class); 
                // Enviar ID del molino a la siguiente activity 
                // intent.putExtra(TAG_ID, ID); 
                
                // Volcar en LogCat el ID seleccionado
                Log.w(DEBUG_TAG, "El molino seleccionado es: " + id);
                
                // starting new activity and expecting some response back 
                // startActivityForResult(intent, 100); 
            } 
        }); 

	}
	public void onClick(View v) {
		// TODO Auto-generated method stub
     	// Obtener el ID del molino seleccionado en el ListItem 
        String idMolino = ((TextView) v.findViewById(R.id.txtListAllID)).getText().toString(); 

        // Volcar en LogCat el ID seleccionado
        Log.w(DEBUG_TAG, "El molino seleccionado es: " + idMolino);
	}
	
	
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }
	
	
	/** 
     * Background Async Task que carga el listado de todos los molinos 
     * 		Subclase privada que crea un hilo aparte para realizar      
     * 		las acciones que deseemos. 
     * */
	private class LoadCercanosMolinos extends AsyncTask<String, Void, Object> {
		/** 
         * Antes de iniciarse el background thread, mostrar Progress Dialog 
         * */
        @Override
        protected void onPreExecute() { 
            super.onPreExecute(); 
            progressDialog = new ProgressDialog(ListCercanoActivity.this); 
            progressDialog.setMessage(getResources().getString(R.string.PD_generando_listado_general));
            progressDialog.setIndeterminate(false); 
            progressDialog.setCancelable(false); 
            progressDialog.show(); 
        } 
        
        /** 
         * Obtener todos los molinos desde la URL
         * */
        protected String doInBackground(String... args) {
        	// JSONObject json = null;
            // Contenedor Parametros 
            List<NameValuePair> params = new ArrayList<NameValuePair>();
           
            Double Latitud = Double.parseDouble(strLatitud) / 1E6;
    		Double Longitud = Double.parseDouble(strLongitud) / 1E6 ;
            
           	// Obtener JSON String desde la URL, mtodo GET            
            if (  strLatitud.length() > 0  ) {
            	
            	params.add(new BasicNameValuePair("LATITUD", String.valueOf(Latitud)));
            }	
            if ( strLongitud.length() > 0 ) {
            	params.add(new BasicNameValuePair("LONGITUD", String.valueOf(Longitud)));
            }
            
            // Volcar en LogCat JSON peticin 
            Log.w(DEBUG_TAG, "En BuscadorMolino: Valor: " + params.toString()); 
            
            JSONObject json = jParser.makeHttpRequest(url_cercano_molinos, "GET", params); 
            
            // Volcar en LogCat JSON response 
           	Log.w(DEBUG_TAG, "Todos los molinos son: " + json.toString());
  
            try { 
                // Comprobando la etiqueta SUCCESS 
                success = json.getInt(TAG_SUCCESS); 
                
                // Volcar en LogCat JSON response  
                Log.w(DEBUG_TAG, "En BuscadorMolino: Error success: " + success);
  
                // Si se ha cargado al menos un registro
                if ( success == 1 ) {
                    // products found 
                    // Getting Array of Products 
                    molinos = json.getJSONArray(TAG_MOLINOS);
                    
                    // Comprobando la etiqueta VOTACIONES
                    int votaciones = json.getInt(TAG_VOTACIONES);
  
                    // looping through All Products 
                    for (int i = 0; i < molinos.length(); i++) { 
                        JSONObject c = molinos.getJSONObject(i); 
  
                        // Storing each json item in variable 
                        String id = c.getString(TAG_ID); 
                        String nombre = c.getString(TAG_NOMBRE); 
                        String tipologia = c.getString(TAG_TIPOLOGIA);
                        int votos = c.getInt(TAG_VOTOS);

                        // Creando el nuevo HashMap 
                        HashMap<String, String> map = new HashMap<String, String>(); 
  
                        // adding each child node to HashMap key => value 
                        map.put(TAG_ID, "Cdigo: " + id); 
                        map.put(TAG_NOMBRE, nombre);
                        map.put(TAG_TIPOLOGIA, "Tipologa: " + tipologia);
                        
                        int valoracion = ( ( votos * 100 ) / votaciones ) / 5 ;
                        map.put(TAG_VOTOS, "Votos: " + String.valueOf(votos) + "/" + votaciones + "  Valoracin: " + valoracion);
 //                       map.put(TAG_VOTACIONES, String.valueOf(valoracion));
  
                        // adding HashList to ArrayList 
                        molinosList.add(map);
                    } 
                    // Informar nmero de molinos encontrados
                    // ListAllActivity.this.textView.setText("Se han listado ...  infraestructuras");
                    
                     
                } else { 
                    // Lista vacia. No se han encontrado molinos 
                	// Toast.makeText(context, getResources().getString(R.string.TM_lista_molinos_vacia), Toast.LENGTH_SHORT).show();
                	// ListAllActivity.this.textView.setText(getResources().getString(R.string.TM_lista_molinos_vacia));
                } 
            } catch (JSONException e) { 
                e.printStackTrace(); 
            } 
            return null; 
            
            
            
    	}
    	       
        
        /** 
         * Antes de iniciarse el background thread, ocultar Progress Dialog 
         * */
    	protected void onPostExecute(Object result) {
    		// Ocultar progressDialog despus de obtener el listado de todos los molinos 
    		progressDialog.dismiss();

            // Actualizar UI desde  Background hilo 
            runOnUiThread(new Runnable() { 
                public void run() { 
                	if ( success == 1 ) { 
                    /** 
                     * Actualizar JSON data en el ListView 
                     * */
                    ListAdapter adapter = new SimpleAdapter( 
                            ListCercanoActivity.this, molinosList, 
                            R.layout.list_item, new String[] { TAG_ID, 
                            								   TAG_NOMBRE, 
                            								   TAG_TIPOLOGIA,
                            								   TAG_VOTOS,
//                            								   TAG_VOTACIONES
                            								   }, 
                            new int[] { R.id.txtListAllID, 
                            		    R.id.txtListAllNOMBRE, 
                            		    R.id.txtListAllTIPOLOGIA,
                            		    R.id.txtListAllVOTOS,
//                            		    R.id.ratingBar1
                            		    }); 
                    // Actualizar listview
                    listView.setAdapter(adapter);
                	} else {
                		Toast.makeText(context, getResources().getString(R.string.TM_lista_molinos_vacia), Toast.LENGTH_SHORT).show();
                	}
                } 
            }); 
    		
    	}
    }
	

	
}