package com.example.molinobd;


import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.location.LocationProvider;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.app.ActionBar;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.widget.*;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.*;

public class MainActivity extends Activity implements  OnClickListener, LocationListener {

	private static final String DEBUG_TAG="Warning";
	// Se definen los botones del Activity principal 
	private ImageButton btnMapa;
	private ImageButton btnMolinosCercanos;
	private ImageButton btnBuscador;
	private ImageButton btnListado;
	
	// Se definen los parmetros para la localizacin GPS
	private LocationManager locationManager;
	private int minTime=60000;
	private int minDistance=1;
	private String provider1=LocationManager.GPS_PROVIDER;
	private String provider2=LocationManager.NETWORK_PROVIDER;
	private String provider;
	private Criteria criteria;
	// URI geogrfico: Iniciado en el Paraninfo de la ULL (S/C de Tenerife). 
	public String strLatitud = "28.481636390458163";
	public String strLongitud = "-16.316443383693695";
	// Estado del GPS: 0 => Desconectado, Cualquier otro valor (1) => Conectado. 
	public int intEstadoGPS = 0;
		
	private String URIGeografico;
	private Location location;
	
	TextView tv;
	
	/** Called when the Activity is first created */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // Vincular a txtEstadoGPS
        tv = (TextView) findViewById(R.id.txtEstadoGPS);
        // Actualizar el estado del GPS en la activity principal 
        if ( isNetworkAvailable() ) {
        	tv.setText(localizar());
        } else {
        	tv.setText(getResources().getString(R.string.TM_gps_red_no_disponible));
        }

               
        // Enlazar los botones, segn la Activity que deben iniciar 
        btnMapa=(ImageButton) findViewById(R.id.btnMapa);
        btnMapa.setOnClickListener(this);
        
        btnMolinosCercanos=(ImageButton) findViewById(R.id.btnMolinosCercanos);
        btnMolinosCercanos.setOnClickListener(this);
        
        btnBuscador=(ImageButton) findViewById(R.id.btnBuscador);
        btnBuscador.setOnClickListener(this); 
        
        btnListado=(ImageButton) findViewById(R.id.btnListado);
        btnListado.setOnClickListener(this);
        
        
    }
     
    public void onClick(View v) {
    	
    	// Si el GPS est activado
    	if ( intEstadoGPS != 0 ) {
    	
    		// Gestionar qu botn fue pulsado
    		Intent intention = null;
    		int id=v.getId();
    		if (id==R.id.btnMapa){
    			// Abrir activity Mapa
    			intention = new Intent(this,MapaActivity.class);   		
    			// Iniciar la Activity Mapa
    			if (intention!= null) {
        			// Pasar los parmetros Longitud y Latitud
        			intention.putExtra("strLatitud", strLatitud);
        			intention.putExtra("strLongitud", strLongitud);

    				startActivity(intention);
    				Toast.makeText(this, getResources().getString(R.string.TM_consultando_mapa), Toast.LENGTH_SHORT).show();
				} else {
 	           		Log.w(DEBUG_TAG, "Warning: No se puede abrir la activity: " + id);
				}

    		}
    		else if (id==R.id.btnMolinosCercanos){
    			// Abrir activity Listado de Molinos Cercanos
    			intention = new Intent(this,ListCercanoActivity.class);
    			if (intention!= null) {
    				// Pasar los parmetros Longitud y Latitud
        			intention.putExtra("strLatitud", strLatitud);
        			intention.putExtra("strLongitud", strLongitud);
        			
    				startActivity(intention);
    				Toast.makeText(this, getResources().getString(R.string.TM_consultando_molinos_cercanos), Toast.LENGTH_SHORT).show();
    			} else {
     	           Log.w(DEBUG_TAG, "Warning: No se puede abrir la activity: " + id);
     	       }

   			}
    		else if (id==R.id.btnBuscador){
    			// Abrir activity buscador
    			intention = new Intent(this,BuscadorActivity.class);
    			if (intention!= null) {
    				startActivity(intention);
    				Toast.makeText(this, getResources().getString(R.string.TM_abriendo_buscador), Toast.LENGTH_SHORT).show();
    			} else {
    	           Log.w(DEBUG_TAG, "Warning: No se puede abrir la activity: " + id);
    	       }
    		}
    		else if (id==R.id.btnListado){
    			// Abrir activity listado general
    			intention = new Intent(this,ListAllActivity.class);
    	        // Volcar en LogCat el ID seleccionado
    			if (intention!= null) { 
    				startActivity(intention);   			
    				Toast.makeText(this, getResources().getString(R.string.TM_generando_listado_general), Toast.LENGTH_SHORT).show();
    	       	} else {
       	           Log.w(DEBUG_TAG, "Warning: No se puede abrir la activity: " + id);
       	       }
    		}
    		else {
    			Toast.makeText(this, getResources().getString(R.string.TM_error_pulsacion), Toast.LENGTH_SHORT).show();
    		}
    	} else {
    		// GPS Desactivado
    		Toast.makeText(this, getResources().getString(R.string.TM_gps_desactivado), Toast.LENGTH_SHORT).show();
    	}
    	
    }

    @Override   
    public boolean onCreateOptionsMenu(Menu menu) {
    	// Crear el men a partir del recurso men
    	MenuInflater inflater = getMenuInflater(); 
    	inflater.inflate(R.menu.activity_main, menu);
       
        // Ocultar fondo    
        // ImageView imageView1=(ImageView)findViewById(R.id.fondo);
        // ImageView.setVisibility(View.INVISIBLE); 
        
        // El mtodo debe devolver un booleano
        return true;
    }
    
    @Override   
    public boolean onOptionsItemSelected(MenuItem item) {
		Intent menuIntention = null;
    	// Gestionar el men a partir del recurso men
		int id=item.getItemId();
		if (id==R.id.menu_activity_main_configuracion){
   			// Abrir activity menu de configuracion
			menuIntention = new Intent(this,activity_menu_config.class);
			if (menuIntention!= null) {
	   	  		startActivity(menuIntention);
	   	  		Toast.makeText(this, getResources().getString(R.string.TM_menu_configuracion), Toast.LENGTH_SHORT).show();
			} else {
		           Log.w(DEBUG_TAG, "Warning: No se puede abrir el men: " + id);
		    }	
		}	
		else if (id==R.id.menu_activity_main_help) { 
   			// Abrir activity menu de ayuda
			menuIntention = new Intent(this,activity_menu_help.class);
			if (menuIntention!= null) {
   	  			startActivity(menuIntention);
   	  			Toast.makeText(this, getResources().getString(R.string.TM_menu_help), Toast.LENGTH_SHORT).show();
			} else {
	           Log.w(DEBUG_TAG, "Warning: No se puede abrir el men: " + id);
	       }
		}
		else if (id==R.id.menu_activity_main_about) { 
   			// Abrir activity menu acerca de... 
   			menuIntention = new Intent(this,activity_menu_about.class);
   			if (menuIntention!= null) {
   	  			startActivity(menuIntention);
   	   			Toast.makeText(this, getResources().getString(R.string.TM_menu_about), Toast.LENGTH_SHORT).show();
   	       } else {
   	           Log.w(DEBUG_TAG, "Warning: No se puede abrir el men: " + id);
   	       }
   	}
        
        // El mtodo debe devolver un booleano
        return true;
    }
    

    // Mtodo que devuelve el ltimo URIGeogrfico 
    private String localizar() {
    	
        // Usar el servicio LocationManager para obtener la localizacin por GPS
        locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);  
        // Definir el mejor de los criteri) para locationManager provider. 
        // Utilizar el proveedor (provider) por defecto.
        criteria = new Criteria();
        provider = locationManager.getBestProvider(criteria, true);
        // Definido el mejor criteria:  
        // bien LocationManager.GPS_PROVIDER
        // o, LocationManager.NETWORK_PROVIDER
        location = locationManager.getLastKnownLocation(provider);
        
    	if (location != null ) {
    		URIGeografico = getResources().getString(R.string.strState) +  provider ;
        	
    		// Convertir coordenada lat/long a Integer 
    		Double Latitud = location.getLatitude();
    		Double Longitud = location.getLongitude();

    		int intLatitudE6 = (int) (Latitud* 1E6);
        	int intLongitudE6 = (int) (Longitud * 1E6);
    		
    		// Salvar los nuevos valores de lat/long en String
    		strLatitud = String.valueOf(intLatitudE6);
    		strLongitud = String.valueOf(intLongitudE6);
    		
    		// GPS Activado
    		intEstadoGPS = 1; 
    		
    		URIGeografico = URIGeografico + "\n"+ getResources().getString(R.string.strLatitud) +": " + strLatitud;
    		URIGeografico = URIGeografico + "\n"+ getResources().getString(R.string.strLongitud) +": " +  strLongitud;
			return URIGeografico;
    		
    	} else {
    		// Por alguna causa, se desconoce la URI geogrfica 
    		Toast.makeText(this, getResources().getString(R.string.TM_gps_desactivado), Toast.LENGTH_LONG).show();
    		// GPS Desactivado
    		intEstadoGPS = 0; 
    		return getResources().getString(R.string.strState) + ": " + getResources().getString(R.string.TM_gps_desactivado);
    	}
    }

    /* Request updates at startup */
    @Override
    protected void onResume() {
      super.onResume();
      locationManager.requestLocationUpdates(provider, 400, 1, this);
      tv.setText(localizar());

    }

    /* Remove the locationlistener updates when Activity is paused */
    @Override
    protected void onPause() {
    	super.onPause();
    	// Para evitar gasto de batera y recursos,
   	 	// se desactiva la localizacin automtica cuando:
   		// a) el proveedor se desactiva o 
   		// b) cuando se abandona la aplicacin 
   		locationManager.removeUpdates(this);
    }



	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}


	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		// tv.append("\n"+getResources().getString(R.string.locate_changed));
		tv.setText(localizar());
	}

	// Mtodo que se ejecuta cuando el proveedor se desactiva
	public void onProviderDisabled(String provider) {
		// Para evitar gasto de batera y recursos,
		// se desactiva la localizacin automtica cuando:
		// a) el proveedor se desactiva o 
		// b) cuando se abandona la aplicacin 
		locationManager.removeUpdates(this);
		
	}

	// Mtodo que se ejecuta cuando el proveedor se activa
	public void onProviderEnabled(String provider) {
		// Se especifica el nombre del proveedor, 
		// junto al mnimo tiempo y la mnima distancia entre actualizaciones
    	locationManager.requestLocationUpdates(provider, minTime, minDistance, this);		

	}

	// Mtodo que se ejecuta cuando el proveedor cambia de estado
	public void onStatusChanged(String provider, int status, Bundle extras) {
		if(status==LocationProvider.AVAILABLE) {
			tv.append("\nStatus changed: AVAILABLE");
		if(status==LocationProvider.OUT_OF_SERVICE)
			tv.append("\nStatus changed: OUT OF SERVICE");
		if(status==LocationProvider.TEMPORARILY_UNAVAILABLE)
			tv.append("\nStatus changed: TEMPORARILY UNAVAILABLE");
		}
	}


	public boolean isNetworkAvailable() {
	    ConnectivityManager cm = (ConnectivityManager) 
	      getSystemService(Context.CONNECTIVITY_SERVICE);
	    NetworkInfo networkInfo = cm.getActiveNetworkInfo();
	    // if no network is available networkInfo will be null
	    // otherwise check if we are connected
	    if (networkInfo != null && networkInfo.isConnected()) {   
	    	return true;
	    }    
	    return false;
	} 
    
    
}

