<?php  // $Id: getmolinojson.php,v 1.0 2012/11/01 13:01:51 $
       // getcercanosjson.php - Obtener lista de molinos cercanos, segn ID.

///////////////////////////////////////////////////////////////////////////
//                                                                       //
// NOTICE OF COPYRIGHT                                                   //
//                                                                       //
// MCanarios - Gua de Molinos de Gofio Canarios						 //	
//             Edicin para dispositivos mviles                         //
//                                                                       //
// Copyright (C) 2012  http://www.wilmerodriguez.mobi/MCanarios          //
//                                                                       //
// This program is free software; you can redistribute it and/or modify  //
// it under the terms of the GNU General Public License as published by  //
// the Free Software Foundation; either version 2 of the License, or     //
// (at your option) any later version.                                   //
//                                                                       //
// This program is distributed in the hope that it will be useful,       //
// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
// GNU General Public License for more details:                          //
//                                                                       //
//          http://www.gnu.org/copyleft/gpl.html                         //
//                                                                       //
///////////////////////////////////////////////////////////////////////////

// Calcular distancia en 
// Fuente: http://www.forosdelweb.com/f91/distancia-entre-dos-puntos-dados-por-longitud-latitud-514993/
// Bajo bajo licencia Creative Commons BY-NC-SA.
function getDistancia($latitud1, $longitud1, $latitud2, $longitud2)
{
	// Para el clculo se asume que la tierra es totalmente esfrica (que no lo es)
	// y que tiene un radio aproximado de 6.366,2 Km.
	// Por tanto, el radio equivolumtrico de la tierra 
	// (el de una esfera que tuviera el mismo volumen que el planeta) 
	// viene andando por los 6.371 Km. 
	// Con ese radio, el cuadrante terrestre medira 40.030 Km, 
	// y el avance por grado sera de 111,195 Km..
	// En nuestra caso se expresar en metros
	$earth = 6376200; // Metros
	//$earth = 3960; // 3960 miles = 6377 Km; cambiar segn el caso
 
	// Coordenadas del primer punto 
	$lat1 = deg2rad( $latitud1);
	$long1= deg2rad( $longitud1);
	
	// Coordenadas del segundo punto 
	$lat2 = deg2rad( $latitud2);
	$long2= deg2rad( $longitud2);
 
	// Diferencias entre puntos
	$dlong=$long2-$long1;
	$dlat=$lat2-$lat1;
 
	$sinlat=sin($dlat/2);
	$sinlong=sin($dlong/2);
 
	
	$a=( $sinlat * $sinlat ) + cos($lat1) * cos($lat2) * ( $sinlong * $sinlong ) ;
	
	$c= 2 * asin ( min (1,sqrt($a)) );
  
	$d=round( $earth * $c);
 
	return $d;
}
	   
/** Inicio del PHP GETMOLINOJSON.PHP
 *  Se verifica que exista el archivo de configuracin, en caso contrario,
 *  	se redirige hacia le proceso de instalacin	
 */	   
if (!file_exists('../config.php')) {
        header('Location: ../install.php');
        die ("Error");
    }

    require_once('../config.php');
    require_once('../require/bdconfig.php');

	// Si se necesita enviar al navegador el XML devuelto, quitar la lnea de abajo
	// echo "Conectando a la base de datos: ", $CFG->dbhost, "<br />";
	
	// Comprobar que se han pasado parmetros
	if ( isset($_GET["LATITUD"]) || isset($_GET["LONGITUD"]) ) { 
		// Seleccionando y conectando a la base de datos
		$db_conexion=mysql_connect($CFG->dbhost, $CFG->dbuser, $CFG->dbpass);
		if (!$db_conexion) {
			die('No se pudo conectar con Base de datos: <br/>' . mysql_error());
		}
		mysql_select_db($CFG->dbname);
		
		// Recuperar datos, escaparlos por seguridad
		$LATITUD = mysql_real_escape_string($_GET['LATITUD']); 
		$LONGITUD = mysql_real_escape_string($_GET['LONGITUD']);

		// Obtener total de votaciones 
		$result = mysql_query("SELECT sum(VOTOS) as VOTACIONES  FROM bdm_molinos");
		if (!empty($result)) { 
    	// Comprobar que exista al menos un resultatdo (Query NO vacia)
			if (mysql_num_rows($result) > 0) { 
				// Bucle que recorre todos los resultados
				$row = mysql_fetch_array($result); 
				$Votaciones = $row["VOTACIONES"]; 
			}
		}		
	
		// Inicializar contador de molinos cercanos a cero
		$HayCercanos = 0;
		
		// Obtener datos del molino pasado como parmetro
		$result = mysql_query('select ID, NOMBRE, TIPOLOGIA, VOTOS, LATITUD, LONGITUD  from bdm_molinos');     
		
		if (!empty($result)) { 
    	// Comprobar que exista al menos un resultatdo (Query NO vacia)
			if (mysql_num_rows($result) > 0) { 
				// Bucle que recorre todos los resultados
				// nodo (molino) solicitado 
				$response["mcanarios"] = array(); 
				
				while( $row = mysql_fetch_array($result, MYSQL_ASSOC) ) {    
				
					$molino = array(); 
					
					// Calcular distancia
					$Distancia = getDistancia( $LATITUD, $LONGITUD, $row["LATITUD"], $row["LONGITUD"]);
					
					// Determinar si es un molino prximo ( a menos de un kilmetro )
					if ( $Distancia <= 1000) {
					
						$molino["ID"] = utf8_encode($row["ID"]); 
					
						$molino["NOMBRE"] = utf8_encode($row["NOMBRE"]); 
						$molino["TIPOLOGIA"] = utf8_encode($row["TIPOLOGIA"]); 
					
						$molino["LATITUD"] = utf8_encode($row["LATITUD"]); 
						$molino["LONGITUD"] = utf8_encode($row["LONGITUD"]); 
					
						$molino["VOTOS"] = utf8_encode($row["VOTOS"]); 
						$molino["DISTANCIA"] = utf8_encode($Distancia); 
					
						array_push($response["mcanarios"], $molino); 
						$HayCercanos = $HayCercanos + 1;
					}
				}
				if ( $HayCercanos > 0 ) {
					// Nmero de Votaciones totales
					$response["VOTACIONES"] = (double) $Votaciones ; 
					
					// Nmero de molinos cercanos
					$response["CERCANOS"] = (double) $HayCercanos ; 
				
					// Proceso realizado 
					$response["success"] = 1; 
				} else {	
					// Nmero de Votaciones totales
					$response["VOTACIONES"] = (double) $Votaciones ; 
					
					// Nmero de molinos cercanos
					$response["CERCANOS"] = (double) $HayCercanos ; 
				
					// Proceso realizado 
					$response["success"] = 20; 
					$response["message"] = "No se han encontrado molinos cercanos."; 
				}
				// Generar respuesta JSON
				echo json_encode($response); 
			} else { 
				// No se ha encontrado resultado (Query vacia)
				$response["success"] = 0; 
				$response["message"] = "Molino no encontrado"; 
  
				// Generar respuesta de resultado no encontrado 
				echo json_encode($response); 
			}
			// Cerrar Query
			mysql_free_result($result);  
        } else { 
			// No se ha encontrado un resultado (Query vacia)
			$response["success"] = 0; 
			$response["message"] = "Molino no encontrado"; 
  
			// Generar respuesta de resultado no encontrado 
			echo json_encode($response); 
		}
		
		// Cerrar conecin a la base de datos
		mysql_close($db_conexion);
		
	} else { 
		// Parmetro (ID) requerido
		$response["success"] = 10; 
		$response["message"] = "Campo(s) requerido(s). ID omitido"; 
  
		// Generar respuesta de resultado no encontrado 
		echo json_encode($response); 
	}	
?>